local frame=CreateFrame("frame",nil,Playerframe)
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("COMBAT_TEXT_UPDATE")
RepWatch = {}
	
function handler(msg) 
if msg=="" then
	ChatFrame1:AddMessage("type /rep off to turn off RepWatch output")
	ChatFrame1:AddMessage("type /rep on to turn RepWatch output back on")
	ChatFrame1:AddMessage("type /rep short to switch to a shorter version of RepWatch output")
	ChatFrame1:AddMessage("type /rep long to to switch back to the Verbose version of RepWatch output")
	ChatFrame1:AddMessage("type /rep time to toggle state of time to rep lvl output")
end
if msg=="G" and not RepWatchHidden then 
	arg3=25
	RepwatchGetrepinfo("Guild Reputation",arg3)
end
if msg=="Long" or msg=="long" or msg=="LONG" or msg=="Verbose" or msg=="verbose" or msg=="VERBOSE" then
	RepWatchVerbose=true
end
if msg=="Short" or msg=="short" or msg=="Terse" or msg=="terse" then
	RepWatchVerbose=false
end
if msg=="on" or msg=="ON" or msg=="On" then
	RepWatchHidden=false
end
if msg=="Off" or msg=="OFF" or msg=="off" then
	RepWatchHidden=true
	ChatFrame1:AddMessage("Hidden=True")
end
if msg=="time" or msg=="Time" or msg=="TIME" then
	if RepWatchTime==true then
		RepWatchTime=false
		ChatFrame1:AddMessage("Time to rep display off")
	else
		RepWatchTime=true 
		ChatFrame1:AddMessage("Time to rep display on")
	end
end	

end
frame:SetScript("OnEvent",function(self,event,arg1,arg2,arg3)
	if event == "PLAYER_ENTERING_WORLD" then
        RepWatchTimeStringLong=""
        RepWatchTimeStringSHort=""
		SLASH_RepWatch1, SLASH_RepWatch2, SLASH_RepWatch3, SLASH_RepWatch4 = "/rep", "/Rep", "/RepWatch", "/repwatch";
		SlashCmdList["RepWatch"] = handler
		if RepWatchVerbose==nil then
			RepWatchVerbose=true
		end
		if RepWatchHidden==nil then
			RepWatchHidden=false
		end
		if RepWatchTime==nil then
			RepWatchTime=true
			ChatFrame1:AddMessage("RepWatchTime=True")
		end
		if RepWatchLoadTime==nil then
			RepWatchLoadTime=GetTime()
		end
		if  RepWatchNumEvents==nil then
			RepWatchNumEvents=0
		end
		if RepWatchTotalEarned==nil then
			RepWatchTotalEarned=0
		end
	end

		if ((event == "COMBAT_TEXT_UPDATE") and(arg1 == "FACTION")) then
--ChatFrame1:AddMessage("Faction name is --"..arg2.."--") -- debug 
		RepwatchGetrepinfo(arg2,arg3)

	end
end)

function RepwatchGetrepinfo(faction,amt)

RepWatchNumEvents=RepWatchNumEvents+1
RepWatchTotalEarned=RepWatchTotalEarned+amt
RepWatchCurentTime=GetTime()
RepWatchAverageAmtEarned=RepWatchTotalEarned/RepWatchNumEvents
RepWatchAverageSeconds=(RepWatchCurentTime-RepWatchLoadTime)/RepWatchNumEvents

if faction=="Guild" then
	faction=Repwatchsubguildname()
end

for factionIndex = 1, GetNumFactions() do
  name, description, standingId, bottomValue, topValue, earnedValue, atWarWith,
    canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild = GetFactionInfo(factionIndex)
  
     if name==faction then index=factionIndex end

end
  name, description, standingId, bottomValue, topValue, earnedValue, atWarWith,
    canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild = GetFactionInfo(index)
	standinglabel=getglobal("FACTION_STANDING_LABEL"..standingId)
if RepWatchTime then
	RepWatchAverageEventsToGO=(topValue-earnedValue)/ RepWatchAverageAmtEarned
	RepWatchHours=floor(((RepWatchAverageEventsToGO*RepWatchAverageSeconds)/60)/60)
	if strlen(RepWatchHours)==1 then
		RepWatchHours="0"..RepWatchHours
	end
	RepWatchMins=floor(((RepWatchAverageEventsToGO*RepWatchAverageSeconds)/60)-RepWatchHours*60)
	if strlen(RepWatchMins)==1 then
		RepWatchMins="0"..RepWatchMins
	end
	RepWatchSecs=ceil(((RepWatchAverageEventsToGO*RepWatchAverageSeconds)-(RepWatchHours*60*60))-(RepWatchMins*60))
	if strlen(RepWatchSecs)==1 then
		RepWatchSecs="0"..RepWatchSecs
	end
RepWatchTimeStringLong=" or about "..RepWatchHours..":"..RepWatchMins..":"..RepWatchSecs
--RepWatchTimeStringLong=" or about "..format("%uu:%uu:%uu", RepWatchHours, RepWatchMins,RepWatchSecs)
RepWatchTimeStringShort=RepWatchHours..":"..RepWatchMins..":"..RepWatchSecs
--RepWatchTimeStringShort=format("%uu:%uu:%uu", RepWatchHours, RepWatchMins,RepWatchSecs)
end

	if standingId <8 then
		nextstandinglabel=getglobal("FACTION_STANDING_LABEL"..standingId+1)
	end
	if standingId == 8 then
		nextstandinglabel="Repcap"
	end
	if not RepWatchHidden then
		if RepWatchVerbose then
			ChatFrame1:AddMessage("Your current standing with "..name.." is "..standinglabel..".  You have "..topValue-earnedValue.." to go to earn "..nextstandinglabel.." or "..ceil((topValue-earnedValue)/amt).." more events like this."..RepWatchTimeStringLong)
		else
			ChatFrame1:AddMessage(name..": "..standinglabel..". "..topValue-earnedValue.." to "..nextstandinglabel..", "..ceil((topValue-earnedValue)/amt).." events."..RepWatchTimeStringShort)

		end
	end
end

function Repwatchsubguildname()
for factionIndex1 = 1, GetNumFactions() do
  name, description, standingId, bottomValue, topValue, earnedValue, atWarWith,
    canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild = GetFactionInfo(factionIndex1)
  if isHeader and name=="Guild" then
	index1=factionIndex1+1
  end
end
    name, description, standingId, bottomValue, topValue, earnedValue, atWarWith,
    canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild = GetFactionInfo(index1)
  return name
end

